/* Automatically generated by Kelbt from "klparse.kh".
 *
 * Parts of this file are copied from Kelbt source covered by the GNU
 * GPL. As a special exception, you may use the parts of this file copied
 * from Kelbt source without restriction. The remainder is derived from
 * "klparse.kh" and inherits the copyright status of that file.
 */

/*
 *  Copyright 2006 Adrian Thurston <thurston@cs.queensu.ca>
 */

/*  This file is part of Kelbt.
 *
 *  Kelbt is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 * 
 *  Kelbt is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with Kelbt; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */

#ifndef KLPARSE_H
#define KLPARSE_H

#include "avltree.h"
#include "parsedata.h"

struct LangEl;
struct Token
{
	char *data;
	InputLoc loc;
};

struct Parser
{
	#define KW_Parser 128
#define KW_Include 129
#define TK_Word 130
#define TK_String 131
#define KW_Commit 132
#define KW_Interface 133
#define KW_Try 134
#define KW_Undo 135
#define KW_Final 136
#define KW_Translate 137
#define KW_Token 138
#define KW_NonTerm 139
#define KW_Uses 140
#define KW_Type 141
#define TK_Number 142
#define TK_Inline 143
#define TK_Reference 144
#define TK_Literal 145
#define _eof 146

	LangEl *freshEl;
	int freshPos;
	LangEl *pool;
	int numRetry;
	int numNodes;
	LangEl *stackTop;
	LangEl *lastFinal;
	int errCount;
	int curs;

	int init();
	int parseLangEl( int type, const Token &token );
	int finish();



	Parser( char *fileName, char *parserName ) : 
		pd( fileName, parserName ), 
		sawStart(false), sawInterface(false) {}

	int token( int tokid, char *data );

	void startSection();
	void endSection();

	ParseData pd;
	bool sawStart;
	bool sawInterface;
	KlangElVect langElVect;
	FactorVect factorVect;
};

struct ParserDictEl
	: public AvlTreeEl<ParserDictEl>
{
	char *name;
	Parser *parser;

	char *getKey() const { return name; };
};

typedef AvlTree<ParserDictEl, char*, CmpStr> ParserDict;

#endif
